package edu.toronto.cs.ctl;

/**
 ** This is an AG CTL node.
 **/
public class CTLAGNode extends CTLAbstractNode
{

  /**
   ** Construct an AG CTL node from another node.
   **/
  protected CTLAGNode (CTLNode phi)
  {
    super (phi);
  }

  public String toString ()
  {
    return "AG " + getRight ();
  }

  public void accept (CTLVisitor v, Object s)
  {
    v.visitAGNode (this, s);
  }

}
