/*
 * KVWServlet.java
 *
 * Created on November 29, 2001, 12:33 PM
 */

package edu.toronto.cs.kegvis;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author  bwong
 * @version
 */
public class KVWServlet extends HttpServlet {
  
  /** Initializes the servlet.
   */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    
  }
  
  /** Destroys the servlet.
   */
  public void destroy() {
    
  }
  
  /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
   * @param request servlet request
   * @param response servlet response
   */
  protected void processRequest(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, java.io.IOException {
    //        response.setContentType("text/html");
    HttpSession session = request.getSession();
    
        /* this is the jsp file that should redisplay everything */
    RequestDispatcher rd = request.getRequestDispatcher("/edu/toronto/cs/kegvis/KVWDisplay.jsp");
    
    String command;
    
    
    command = request.getParameter("command");
    
    KVWSession kvwsession = (KVWSession) session.getAttribute("kvwsession");
    if (kvwsession == null) {
      // need to generate a new counter-example
      
      //default stuff
      //String ctlString = "EX (offhook \\/ calleesel)";
      //String filename = "play/gxl/3rdmergedphone1.xml";
            String ctlString = "EX CONNECTED";
            String filename = "play/models/phone/caller-callee3-4val.xml";
      
      kvwsession = new KVWSession(filename);
      kvwsession.setCtlString(ctlString);
      System.out.println("Counter-example generated.");
      session.setAttribute("kvwsession", kvwsession);
    }
    
    System.out.println(command);
    if (command == null) {
      // probably just browsed here, do nothing
    }
    else if (command.equals("step1")) {
      kvwsession.addSteps();
    }
    else if (command.equals("pickleft")) {
      kvwsession.setChoice(1);
      kvwsession.addSteps();
    }
    else if (command.equals("pickright")) {
      kvwsession.setChoice(0);
      kvwsession.addSteps();
    }
    else if (command.equals("reset")) {
      kvwsession.resetTrace();
    }
    else if (command.equals("newctl")) {
      kvwsession.resetTrace();
      String ctlString = request.getParameter("ctl");
      System.out.println("CTL: " + ctlString);
      kvwsession.setCtlString(ctlString);
    }
    else if (command.equals("newfilename")) {
      kvwsession.resetTrace();
      String filename = (String) request.getParameter("filename");
      kvwsession.setFilename(filename);
    }
    
    request.setAttribute("ctlString", kvwsession.getCtlString());
    request.setAttribute("filename", kvwsession.getFilename());
    request.setAttribute("kvwsession", kvwsession);
    rd.forward(request, response);
  }
  
  /** Handles the HTTP <code>GET</code> method.
   * @param request servlet request
   * @param response servlet response
   */
  protected void doGet(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, java.io.IOException {
    processRequest(request, response);
  }
  
  /** Handles the HTTP <code>POST</code> method.
   * @param request servlet request
   * @param response servlet response
   */
  protected void doPost(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, java.io.IOException {
    processRequest(request, response);
  }
  
  /** Returns a short description of the servlet.
   */
  public String getServletInfo() {
    return "KEGVis";
  }
  
}
