package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.ctl.*;

/**
 ** This is an abstract CTL node.
 **/
public class FairNodeNamer extends CTLVisitorDefaulterAncestor
{
  public void visitAbstractNode (CTLAbstractNode n, Object stateinfo)
  {
    ((StringBuffer)stateinfo).append ("?n?:");
  }

  public void visitAFNode (CTLAFNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("AcF ");
    else

      ((StringBuffer)stateinfo).append ("AF ");
  }
  
  public void visitAGNode (CTLAGNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("AcG ");
    else
      ((StringBuffer)stateinfo).append ("AG ");
  }
  
  public void visitAUNode (CTLAUNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("AcU ");
    else
      ((StringBuffer)stateinfo).append ("AU ");
  }
  
  public void visitAUiNode (CTLAUiNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("AcUi ");
    else

      ((StringBuffer)stateinfo).append ("AUi ");
  }
  
  public void visitAWNode (CTLAWNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("AcW ");
    else

      ((StringBuffer)stateinfo).append ("AW ");
  }
  
  public void visitAXNode (CTLAXNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("AcX ");
    else

      ((StringBuffer)stateinfo).append ("AX ");
  }
  
  public void visitEFNode (CTLEFNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("EcF ");
    else

      ((StringBuffer)stateinfo).append ("EF ");
  }
  
  public void visitEGNode (CTLEGNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("EcG ");
    else

      ((StringBuffer)stateinfo).append ("EG ");
  }
  
  public void visitEUNode (CTLEUNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("EcU ");
    else

      ((StringBuffer)stateinfo).append ("EU ");
  }
  
  public void visitEUiNode (CTLEUiNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("EcUi ");
    else

      ((StringBuffer)stateinfo).append ("EUi ");
  }
  
  public void visitEWNode (CTLEWNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("EcW ");
    else

      ((StringBuffer)stateinfo).append ("EW ");
  }
  
  public void visitEXNode (CTLEXNode node, Object stateinfo)
  {
    if (node.getFairness ().size () != 0)
      ((StringBuffer)stateinfo).append ("EcX ");
    else
      ((StringBuffer)stateinfo).append ("EX ");
  }
  
  
}

