package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.keg.*;

public class PrettyDefaultCtlLabelStrategy implements PrettyCtlLabelStrategy
{
  String standardBanner = "";
  String standardFooter = "";

  public PrettyDefaultCtlLabelStrategy ()
  {
  }

  public void setOwnerState (KEGStateNode owner)
  {
  }

  protected String getBanner (KEGStateNode node, Object stateinfo)
  {
    return standardBanner;
  }

  protected String getFooter (KEGStateNode node, Object stateinfo)
  {
    return standardFooter;
  }

  public PrettyDefaultCtlLabelStrategy setBanner (String b)
  {
    standardBanner = b;
    return this;
  }
  
  public PrettyDefaultCtlLabelStrategy setFooter (String f)
  {
    standardFooter = f;
    return this;
  }
  
  public Object getLabel (KEGCtlNode node, Object stateinfo)
  {
    StringBuffer sb = new StringBuffer ();
    sb.append (standardBanner);
    sb.append (getVariableLabelSection (node, stateinfo));
    sb.append (standardFooter);
    return sb.toString ();
  }

  StringBuffer getVariableLabelSection (KEGCtlNode node, Object stateinfo)
  {
    return new StringBuffer (node.getCTL ().toString ());
  }
}
