package edu.toronto.cs.prettygraph;

import edu.toronto.cs.util.dgraph.*;

/**
 * DVGraphNodeFactory.java
 *
 *
 * Created: Fri Jul 13 19:42:41 2001
 *
 * @author <a href="mailto:cdtw@cs.toronto.edu">Christopher D. Thompson-Walsh</a>
 * @version
 */

public class PrettyKegNodeFactory extends PrettyNodeFactory
{
  public PrettyKegNodeFactory ()
  {
    
  }

  public PrettyKegGraphNode createNode (PrettyKegGraphNode target, 
					String name)
  {
    return (PrettyKegGraphNode)obtainNode (target, name);
  }

  //  public PrettyKegGraphNode createNode (String name)
  //{
  //  return (PrettyKegGraphNode)obtainNode (null, name);
  //}

  public DGUniqueNode instantNode (Object ident)
  {
    return new PrettyKegGraphNode ((String)ident, this);
  }
  
  public boolean addOk (DGNode node)
  {
    if (node instanceof PrettyKegGraphNode)
      {
	((PrettyKegGraphNode)node).setFOwner (this);
	doAdd (node);
	return true;
      }
    return false;
  }
  
  
}// PrettyNodeFactory








