package edu.toronto.cs.util.dgraph;

import java.util.*;

//import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;

public class DGMultiEdge extends DGEdge
{
  static Logger log = new Logger ("PrettyGraphMMDDEdge");
  Set values;
  
  public DGMultiEdge (DGNode origin, DGNode destination)
  {
    super (origin, destination);
    values = new HashSet ();
  }

  public Iterator getSubEdges ()
  {
    return values.iterator ();
  }

  // Debugging.
  public Set getValues ()
  {
    return values;
  }
  
  
  public DGMultiEdge addSubEdge (DGEdge edge)
  {
    values.add (edge);
    return this;
  }

  public void accept (DGEdgeVisitor visitor, Object stateinfo)
  {
    visitor.visitDGMultiEdge (this, stateinfo);
  }
      
}




