package edu.toronto.cs.ctl;

/**
 ** This is a Neg CTL node.
 **/
public class CTLNegNode extends CTLAbstractNode
{

  /**
   ** Construct a Neg CTL node from another node.
   **/
  protected CTLNegNode (CTLNode phi)
  {
    super (phi);
  }

  public String toString ()
  {
    return "!" + getRight ();
  }


  public void accept (CTLVisitor v, Object s)
  {
    v.visitNegNode (this, s);
  }


}





